#include "js-gtk.h"

JSGTK_CLASS(Dialog);

static JSBool dialog_ctor(JSContext *cx, JSObject *obj,
			  uintN argc, jsval *argv, jsval *rval) {
    GtkDialog *dialog;
    JSObject *vbox;
    JSObject *action;
    
    dialog = GTK_DIALOG(gtk_dialog_new());
    if (!dialog)
	return JS_FALSE;
    JS_SetPrivate(cx, obj, dialog);
    jsgtkobj_registerWrapper(cx, GTK_OBJECT(dialog), obj);
    
    vbox = jsgtkobj_wrapObject(cx, dialog->vbox);
    action = jsgtkobj_wrapObject(cx, dialog->action_area);
    
    if (!JS_DefineProperty(cx, obj, "vbox", OBJECT_TO_JSVAL(vbox),
			   NULL, NULL,
			   JSPROP_READONLY|JSPROP_PERMANENT|JSPROP_ENUMERATE))
	return JS_FALSE;	/* XXX */

    if (!JS_DefineProperty(cx, obj, "action_area",
			   OBJECT_TO_JSVAL(action_area), NULL, NULL,
			   JSPROP_READONLY|JSPROP_PERMANENT|JSPROP_ENUMERATE))
	return JS_FALSE;	/* XXX */
    
    return JS_TRUE;
}

#define dialog_methods NULL
JSGTK_INIT_FUNC(dialog,Dialog,0);
