#include "js-gtk.h"

#define SET_FUNC(name)						\
static JSBool misc_set_##name(JSContext *cx, JSObject *obj,		\
			      uintN argc, jsval *argv, jsval *rval) {	\
    GtkMisc *misc;							\
    int32 arg1, arg2;							\
    if (argc < 2 ||							\
	!JSVAL_IS_INT(argv[0]) || !JSVAL_IS_INT(argv[1]))		\
	return JS_FALSE;						\
    GET_GTK(misc,cx,obj,MISC);					\
    if (!JS_ValueToInt32(cx, argv[0], &arg1) ||				\
	!JS_ValueToInt32(cx, argv[1], &arg2))				\
	return JS_FALSE;						\
    gtk_misc_set_##name(misc, arg1, arg2);				\
    return JS_TRUE;							\
}

SET_FUNC(alignment)
SET_FUNC(padding);

#undef SET_FUNC

JSGTK_CLASS(Misc);

static JSFunctionSpec misc_methods[] = {
    {"set_alignment",	misc_set_alignment,	2},
    {"set_padding",	misc_set_padding,	2},
    {0}
};

JSBool jsgtkarrow_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtkimage_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtklabel_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtkpixmap_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtkentry_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtklist_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtkscrolled_window_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtklist_item_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtkmenu_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtkmenu_item_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtkmenu_bar_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtkadjustment_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtktext_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
/* non bool funcs */
JSObject *jsgtkeditable_init(JSContext *cx, JSObject *global, JSObject *gtkproto);

JSBool jsgtkmisc_init(JSContext *cx, JSObject *global, JSObject *gtkproto) {
  JSObject *miscProto;
  JSObject *editableProto;  

  miscProto = JS_InitClass(cx, global, gtkproto, &jsgtk_MiscClass,
			   NULL, 0,
			   NULL, misc_methods,
			   NULL, NULL);

  editableProto = jsgtkeditable_init(cx, global, miscProto); 

  if (!miscProto || !editableProto || 
      !jsgtkarrow_init(cx, global, miscProto) ||
      /*	!jsgtkimage_init(cx, global, miscProto) || */
      !jsgtklabel_init(cx, global, miscProto) ||
      !jsgtkpixmap_init(cx, global, miscProto) ||
      !jsgtkentry_init(cx, global, editableProto) ||
      !jsgtklist_init(cx, global, miscProto) ||
      !jsgtkscrolled_window_init(cx, global, miscProto) ||
      !jsgtklist_item_init(cx, global, miscProto) ||
      !jsgtkmenu_init(cx, global, miscProto) ||
      !jsgtkmenu_item_init(cx, global, miscProto) ||
      !jsgtkmenu_bar_init(cx, global, miscProto) ||
      !jsgtkadjustment_init(cx, global, miscProto) ||
      !jsgtktext_init(cx, global, editableProto)
      )	
    return JS_FALSE;
  
  return JS_TRUE;
}
