#include "js-gtk.h"

JSGTK_CLASS(ScrolledWindow);

static JSBool scrolled_window_ctor (JSContext *cx, JSObject *obj,
			 uintN argc, jsval *argv, jsval *rval) {
    GtkWidget *scrolled_window;
    
    scrolled_window = gtk_scrolled_window_new(NULL, NULL);
    JS_SetPrivate(cx,obj, scrolled_window);
    jsgtkobj_registerWrapper(cx, GTK_OBJECT(scrolled_window), obj);
    return JS_TRUE;
}

static JSBool add_with_viewport (JSContext *cx, JSObject *obj,
			 uintN argc, jsval *argv, jsval *rval) {

  GtkScrolledWindow *scrolled_window;
  JSObject *widget_wrapper;
  GtkWidget *widget;

  if (argc < 1 || !JSVAL_IS_OBJECT(argv[0]))
      return JS_FALSE;
  GET_GTK(scrolled_window, cx, obj, SCROLLED_WINDOW);

  /* Grab the widget wrapper, then suck out its widget */
  widget_wrapper = JSVAL_TO_OBJECT(argv[0]);
  GET_GTK(widget,cx,widget_wrapper,WIDGET);
  //  gtk_scrolled_window_add_with_viewport( GTK_SCROLLED_WINDOW(scrolled_window), widget);
  gtk_scrolled_window_add_with_viewport( scrolled_window, widget);
  return JS_TRUE;
}

static JSFunctionSpec scrolled_window_methods[] = {
  {"add_with_viewport", add_with_viewport, 1},
  {0}
};

JSGTK_INIT_FUNC(scrolled_window,ScrolledWindow,2);
