#include "js-gtk.h"

#define SIMPLE_FUNC(funcname) \
  SIMPLE_WRAPPER_FUNC(widget,Widget,WIDGET,funcname)
#define WIDGET_FUNC(funcname) \
  WIDGET_WRAPPER_FUNC(widget,Widget,WIDGET,funcname)
#define INT_FUNC(funcname) \
  INT_WRAPPER_FUNC(widget,Widget,WIDGET,funcname)

SIMPLE_FUNC(destroy);
SIMPLE_FUNC(show);
SIMPLE_FUNC(hide);
SIMPLE_FUNC(map);
SIMPLE_FUNC(unmap);
SIMPLE_FUNC(realize);
SIMPLE_FUNC(unrealize);
SIMPLE_FUNC(draw_focus);
/*SIMPLE_FUNC(draw_children);*/
SIMPLE_FUNC(draw_default);
SIMPLE_FUNC(grab_focus);
SIMPLE_FUNC(grab_default);
/*SIMPLE_FUNC(restore_state);*/
WIDGET_FUNC(set_parent);
WIDGET_FUNC(reparent);
INT_FUNC(set_state);

JSBool widget_set_usize(JSContext *cx, JSObject *obj,
			     uintN argc, jsval *argv, jsval *rval) {  
  GtkWidget *widget;
  
  if (argc < 2 || !JSVAL_IS_INT(argv[0]))
      return JS_FALSE;
  
  GET_GTK(widget,cx,obj,WIDGET);
  gtk_widget_set_usize(widget, JSVAL_TO_INT(argv[0]), JSVAL_TO_INT(argv[0]));
  return JS_TRUE;
}

#undef SIMPLE_FUNC

JSGTK_CLASS(Widget);

#define DECL(name,args) \
{#name, widget_##name, args}

static JSFunctionSpec widget_methods[] = {
    DECL(destroy,0),
    DECL(show,0),
    DECL(hide,0),
    DECL(map,0),
    DECL(unmap,0),
    DECL(realize,0),
    DECL(unrealize,0),
    DECL(draw_focus,0),
    DECL(draw_default,0),
    DECL(grab_focus,0),
    DECL(grab_default,0),
   /* DECL(restore_state,0),*/
    {"set_usize", widget_set_usize, 2},
    {0}
};

#undef DECL

JSBool jsgtkcontainer_init(JSContext *, JSObject *, JSObject *);
JSBool jsgtkmisc_init(JSContext *, JSObject *, JSObject *);
JSBool jsgtkseparator_init(JSContext *, JSObject *, JSObject *);
JSBool jsgtktooltips_init(JSContext *, JSObject *, JSObject *);
JSBool jsgtkprogressbar_init(JSContext *, JSObject *, JSObject *);

JSBool jsgtkwidget_init(JSContext *cx, JSObject *global, JSObject *gtkproto) {
    JSObject *widgetProto;

    widgetProto = JS_InitClass(cx, global, gtkproto, &jsgtk_WidgetClass,
			       NULL, 0,
			       NULL, widget_methods,
			       NULL, NULL);
    if (!widgetProto ||
	!jsgtkcontainer_init(cx, global, widgetProto) ||
	!jsgtkmisc_init(cx, global, widgetProto) ||
	!jsgtkseparator_init(cx, global, widgetProto) ||
	!jsgtktooltips_init(cx, global, widgetProto) ||
	!jsgtkprogressbar_init(cx, global, widgetProto))
	return JS_FALSE;
    return JS_TRUE;
}


